<?php
/*

Plugin Name: GRA4 Social Network

Plugin URI: http://gra4.com/groups/profile/98/gra4-webmasters-wordpress

Description: Social networks put plenty of web communities out of commission - anyone can create a group on Facebook, and it's much easier than to build and support whole website. We want to get web-masters back into the game - with GRA4 any WP installation can get it's own full-blown social networking subsystem.

Author: GRA4

Author URI:http://gra4.com

Version: 0.0.0.7

 */

/*

HOW TO INSTALL

 - Make sure at Settings -> Permalinks -> Common Settings your WordPress uses anything but "Default"(sorry, SEO-friendly URLs required).

 - Download the Plugin

 - Create a new page for your GRA4 social network to display on.  

 - Make Visibility of this page "Public"

 - Edit Permalink of the page, set it to "gra4" (without quotation marks)

 - Under HTML tab add text "[GRA4_CONTENT]" (without quotation marks)
 
 - Publish the page.
 
 - Head to Dashboard -> Plugins -> Add New -> Upload

 - Browse to the .zip file you downloaded and click open

 - Click Install

 - Click Activate

 - (Optional) Use Admin interface (admin dashboard->menu->GRA4->GRA4) to configure the appearance.
 
 - DONE! It’s that easy



CUSTOMIZATION

This plugin is tested on the standard themes. 

If you using custom themes, or just want your GRA4 to look a bit different, 
rename file custom.css_ in your wp-content/plugins/gra4/css/ directory as custom.css and edit.

Width of the GRA4 content set to 1000px;

COMPATIBILITY

This plugin is tested on the standard themes. 
The width of the content is about 1000px, so we recommend to start with wide template with no sidebars.

SUPPORT GROUP

http://gra4.com/groups/profile/98/gra4-webmasters-wordpress

*/

class gra4
{
	function gra4()
    {
		ob_start(); //GRA4 may send headers out - so we prevent warning
		
		register_activation_hook( __FILE__, array( $this, 'set_theme_options' ) );
		
		//Activation Hook
		add_action('init', array (&$this,'init_func'));
		
		add_filter('upgrader_pre_install', array (&$this,  'gra4_backup'));
		add_filter('upgrader_post_install', array (&$this, 'gra4_recover'));
		
        if (function_exists ('add_shortcode') )
        {
			add_shortcode('GRA4_CONTENT', array (&$this, 'content_func')); 
			
			add_filter( 'rewrite_rules_array', array (&$this, 'set_seo_friendly_rules'));			

			// admin page
			add_action('admin_menu',  array (&$this, 'admin') );
			
			if (strstr($_SERVER['REQUEST_URI'], '/gra4')){
//				add_action('widgets_init', array (&$this,'remove_sidebars'), 20);
				
				add_action('wp_print_scripts', array (&$this, 'enqueue_scripts') );		
				add_filter('the_content', array (&$this, 'filter'));
			}
    	}

	}

	// Set default THEME option when the plug-in is activated
	function set_theme_options()
	{
		add_option( 'gra4_dom_tree', 'none');
		add_option( 'gra4_dom_node_id', '');
			
		add_option( 'gra4_margin_none', '1');
			
		add_option( 'gra4_set_width', 'none');
		add_option( 'gra4_delta_width', '0');
			
		$themeName = wp_get_theme();
		if( $themeName == 'Twenty Ten'){
			update_option( 'gra4_dom_tree', '2');
			update_option( 'gra4_dom_node_id', 'main');
			update_option( 'gra4_set_width', '1');
			update_option( 'gra4_delta_width', '1');
			update_option( 'gra4_margin_none', '1');
			$this->set_place( 'main', '1', '1');
			
			$path_to_css = plugin_dir_path(__FILE__).'css/custom.css';
			$content = "\n\r#access{ width:1000px;}";
			
			if (!file_exists( $path_to_css)) {
				$txt_fileName = plugin_dir_path(__FILE__).'css/custom.css_';
				if (file_exists($txt_fileName)) {
					if(!copy($txt_fileName, $path_to_css)){		// copy file
			    		echo "ERROR: Can't create css file";
					}
					unlink( $txt_fileName); // delete custom.css_
				}
				else{
    				echo "ERROR: Bad package.";
				}
			}			
			
			if (is_writable($path_to_css)) {
			    $handle = fopen($path_to_css, 'a'); // add content
			    fwrite($handle, $content);
			    fclose($handle);
			} else {
			    echo "ERROR: File $path_to_css not writable.";
			}
		}
		elseif( $themeName == 'Twenty Eleven'){
			update_option( 'gra4_dom_tree', '2');
			update_option( 'gra4_dom_node_id', 'main');
			update_option( 'gra4_set_width', 'none');
			update_option( 'gra4_delta_width', '-1');
			update_option( 'gra4_margin_none', '1');
			$this->set_place( 'main', 'none', '-1');
		}
	}

	function admin()
	{		
			add_menu_page( 'GRA4  Settings', 'GRA4  Settings', 8, basename(__FILE__), 
							array (&$this,'admin_option_page'));
			add_submenu_page( basename(__FILE__), 'GRA4 Info', 'GRA4 Info', 8, 'admin_info_page',
							array(&$this,'admin_info_page'));							
	}

	function admin_info_page()
	{
		$plugin_dir_path = plugin_dir_path(__FILE__);
		?>
        <div class="wrap">      
        	<h2 style="color:#21759B;">GRA4 Social Network Plugin</h2>
        	<p><? @readfile( $plugin_dir_path.'admin-text.txt') ?></p>        
        </div>
        <?
    }

	function saved()	
	{
		?>
        <script>
			jQuery('#result').html('Changes are saved successfully!').show(1000);
		</script>
        <?
	}
	
	function admin_option_page()
	{
     	define('IN_GRA4', true);
    	require_once('gra4_functions.php');
		?>
        <div class="wrap">      
        	<h2 style="color:#21759B;">GRA4 Settings</h2><hr />
            <div id="result"
            	style="background:#FF9; border-radius:10px; font-size:14px; padding:5px; display:none;">
        </div>
		<?
	  if( $_SERVER['REMOTE_ADDR'] == '127.0.0.1' ){
		  ?>
		<div style="background:#FF9; border-radius:10px; font-size:14px; padding:5px;">
			GRA4 is not intended to operate on a local machine.<br />
		</div>
          <?
		  return;
	  }

		$GRA4_secret = GRA4GetConfigValue('GRA4_secret');
		
	  if( $GRA4_secret != '' OR strstr( $GRA4_secret, 'TMP') )
	  {
		?>
            <form method="post" >
		<?
		
	// 1. GRA4 special position
		include('vendors/simpledom/simple_html_dom.php');		
		$html = file_get_html( get_home_url().'/gra4'); //like 'http://mydomen.ru/WP/gra4'
		$ret = $html->getElementById('#gra4_wordpress');
		$tree = array();
		$tree[] = $ret->parent();
		$i = 0;
		while( $tree[$i]->tag != 'body'){
			$tree[] = $tree[$i]->parent();
			$i++;
		}
		$tree = array_reverse($tree);   // DOM tree
		
		$replace_flag = 0;
		$dom_options = '';
		$dom_node_id = '';
		$margin_option = '';
		$set_width = '';
		$delta_width = '0';
		if($_POST['Submit'])
		{
			$dom_options = $_POST['place'];
			update_option( 'gra4_dom_tree', $dom_options);
			$replace_flag = 1;
			$this->saved(); // info string
			
			// margin option
			if( $_POST['margin_none'])
			{
				update_option( 'gra4_margin_none', '0');
				$margin_option = 0;
			}
			else
			{
				$margin_option = 1;
				update_option( 'gra4_margin_none', '1');
			}
			// set width option
			if( $_POST['set_width'])
			{
				$set_width = $_POST['set_width'];
				update_option( 'gra4_set_width', $set_width);
			}
		}
		else
		{
			 $dom_options = get_option( 'gra4_dom_tree');
			 $dom_node_id = get_option( 'gra4_dom_node_id');
			 $margin_option = get_option( 'gra4_margin_none');
			 $set_width = get_option( 'gra4_set_width');
			 $delta_width = get_option( 'gra4_delta_width');
		}
		
		?>
	<h2>Visualization</h2>

<p>Optional.<br />
Use only if your social content looks shifted, or overlaps with the sidebar.<br />
Some Themes do not provide options to hide sidebars for a particular page, or too narrow to accommodate the GRA4 content.<br />
If in the default position your social content collides with other elements of the page, you may want to move the GRA4 block up in the page elements hierarchy, and/or make upper elements wider.<br />
Sorry, there is to universal settings working for every custom Theme, so, play with the controls, save options,  and 
<a href="<? echo get_home_url().'/gra4'; ?>" target="_blank">see how your social network looks</a>.</p>

<table>
<tr><td style=" font-weight:bold; text-align:center">GRA4 block position</td>
<td style=" font-weight:bold; text-align:center">Make wide</td></tr>
<tr >
<td width="300px" style="border-top:1px solid #21759B; border-bottom:1px solid #21759B;">
		<?
		$step = '&nbsp;';
		echo '<input name="place" type="radio" disabled value="body"';
		echo '> '.$step.'BODY</input><br>';
		$step .= '&nbsp;';		
		for( $i=1; $i < count($tree); $i++){
//			if( $tree[$i]->class)	$treeClass = ' class='.$tree[$i]->class;
			if( $tree[$i]->id){
				$treeId = ' id='.$tree[$i]->id;
				
				echo '<input name="place" type="radio" value="'.$i.'"';
				if( $dom_options == $i){
				 	echo ' checked="checked"';
					$replace_string = $tree[$i]->id;
					update_option( 'gra4_dom_node_id', $replace_string);
				}
				echo '> ';
			 	echo $step.$tree[$i]->tag.$treeId.'</input><br>';
				$step .= '&nbsp;&nbsp;';
			}
		}
		echo '<br><input name="place" type="radio" value="none"';
		if( $dom_options == 'none') 
			echo ' checked="checked" ';
		echo '> '.$step.'GRA4 default position</input><br>';
		
		?>
</td>
<td width="300px" style="border-top:1px solid #21759B; border-bottom:1px solid #21759B;">
		<?
		$step = '&nbsp;';
		echo '<input name="set_width" type="radio" disabled value="body"';
		echo '> '.$step.'BODY</input><br>';
		$step .= '&nbsp;';		
		$last_i = 0;		
		for( $i=1; $i < count($tree); $i++){
//			if( $tree[$i]->class)	$treeClass = ' class='.$tree[$i]->class;
			if( $tree[$i]->id){
				$treeId = ' id='.$tree[$i]->id;
				
				echo '<input name="set_width" type="radio" value="'.$i.'"';
				if( $set_width == $i){
				 	echo ' checked="checked"';
					$set_width = $i;
				}
				echo '> ';
			 	echo $step.$tree[$i]->tag.$treeId.'</input><br>';
				$step .= '&nbsp;&nbsp;';
				$last_i = $i;				
			}
		}
		$last_i++;
		echo '<br><input name="set_width" type="radio" value="'.$last_i.'"';
		if( $set_width == $last_i OR $set_width == 'none' ) echo ' checked="checked" ';
		echo '> '.$step.'GRA4 block</input><br>';
		
		// get DELTA
		if($dom_options == 'none'){
			$delta_width = $last_i - $set_width;
		}
		else{
			$delta_width = $dom_options - $set_width;
		}
		update_option('gra4_delta_width', $delta_width);
		?>

</td>
</tr>
</table>        

        <br />
        <p>To maximize space, available for the social content, we recommend to suppress the frame of the parent element of the page. </p>

		<input type="checkbox" name="margin_none" 
        <?
		if($margin_option == 1)
		{
			echo '>';
		}
		else
		{
			echo ' checked="checked">';
		}
		?>
        
        	&nbsp;      Suppress parent frame
        </input>

        
        <br />
   			<input type="hidden" name="action" value="update" />
   			<input type="hidden" name="replace_string" value="<? echo $replace_string?>" />
            <br>
   			<input type="submit" name="Submit" value="<?php _e('Save') ?>" />
		</form>
        <?
//echo '$dom_options='.$dom_options.'<br>';		
//echo '$set_width='.$set_width.'<br>';
//echo '$margin_option='.$margin_option.'<br>';
//echo '$delta_width='.$delta_width.'<br>';
		
		if($replace_flag == 1){
			$this->set_place($replace_string, $margin_option, $delta_width);
		}
		
		$html->clear(); // clean data
		unset($html);?>
<hr />

<iframe width="480" height="360" src="http://www.youtube.com/embed/ORBR8ql_UPw?rel=0" frameborder="0" allowfullscreen></iframe>
<hr />

<br />        
<h2>Also...</h2>
<p>If you done with the configuration, please</p>
<p>- Edit your Profile<br />
- Upload your Avatar<br />
- Visit your Groups, configure the group of your website, it will help you to promote and manage your social community.<br />
- Take a look at the 
<a href="http://gra4.com/groups/profile/98/gra4-webmasters-wordpress/" target="_blank">
WordPress</a>
and 
<a href="http://gra4.com/groups/profile/94/gra4-webmasters/" target="_blank">
Webmasters</a> groups.</p>

<p>See <a href="<? echo admin_url().'admin.php?page=admin_info_page' ?>">Info</a> page for additional information.</p>
        
       <?		
	  }// END registered in GRA4
	  
	  
	  else
	  {
		if(!function_exists('mb_strlen'))
		{
			?>
			<div style="background: #F93; border-radius:10px; font-size:14px; padding:5px;">
    	    	<center>The <b>sbstring</b> extension library is not available.
					<br />Please adjust your PHP configuration.</center>        
			</div>            
			<?		
		}
		else
		{
		  ?>
		<div style="background:#FF9; border-radius:10px; font-size:14px; padding:5px;">
			Your website is not connected to the GRA4 network yet.<br />
			Please <a href="<? echo get_home_url().'/gra4'; ?>" target="_blank">visit your GRA4 subsystem</a>
            to complete the initialization process, then reload this page.
		</div>
          <?
		}
	  }// END dont registered in GRA4
	  
		?>
        </div>        
        <?
		//$this->set_theme_options();
 	}
	

	// Set GRA4 position on the page
	function set_place( $replace_string, $margin = 1, $delta_width = -1)
	{
		$fileName = dirname(__FILE__).'/js/header.js';
		if ( file_exists($fileName)) {
			$strings = file($fileName);
			$strings[0] = "var place = '$replace_string';\r\n";
			
			if( $margin == 0){
				$strings[1] = "var margin = '0';\r\n";
			}
			else
			{
				$strings[1] = "var margin = '1';\r\n";
			}
			
//			if( $delta_width < 0){
//				$strings[2] = "var set_width = 0;\r\n";
//			}
//			else
			{
				$strings[2] = "var set_width = $delta_width;\r\n";
			}
			
			file_put_contents ($fileName, $strings);		
		}
		else{
    		echo "ERROR: Please make sure file 'header.js' do exist in the plugin 'js' directory.";
		}
	}

	
	function get_pageid()
	{
		global $wpdb;
		return $wpdb->get_var("SELECT ID FROM $wpdb->posts WHERE post_content LIKE '%[GRA4_CONTENT]%' AND post_status = 'publish' AND post_type = 'page'");
	}

	//Shortcode Hook
	function content_func($atts) 
	{
     	define('IN_GRA4', true);
		
		if( $_SERVER['REMOTE_ADDR'] == '127.0.0.1' ){
		  ?>
			<div style="background:#FF9; border-radius:10px; font-size:14px; padding:5px;">
				GRA4 is not intended to operate on a local machine.<br />
			</div>
          <?
		  return;
		}
		
		if(!function_exists('mb_strlen'))
		{
			?>
			<div style="background: #F93; border-radius:10px; font-size:14px; padding:5px;">
    	    	<center>The <b>sbstring</b> extension library is not available.
					<br />Please adjust your PHP configuration.</center>        
			</div>            
			<?
			return;
		}
		
		
    	require_once('gra4_functions.php');

//To give a hint to the people who do not read README files =)
	    if(mb_strpos($_SERVER['REQUEST_URI'],'/gra4') === false)
	    {
		    return("FATAL ERROR: Can't process the URL ! Permalink of this page is not set to 'gra4'? Permalink Settings are set to 'Default'? ");
    	}
//first let's figure out if it's request for CSS

		$strShortSelf = str_replace(mb_strrchr($_SERVER['PHP_SELF'], '/'), '', $_SERVER['PHP_SELF']);

		$aCssNames = explode(',', $aGRA4GlobalConfig['include_css']);


		for ($i = 0; $i < count($aCssNames); $i++) 
		{

	    	if ( trim($_SERVER['REQUEST_URI'] , '/') == trim($strShortSelf . '/gra4' . $aCssNames[$i],'/') ) 
			{

	        	$strFileName = dirname(__FILE__) . $aCssNames[$i]; //see gra4_config.php
				

				if (file_exists($strFileName)) {
		        	$strFileContent = file_get_contents($strFileName);

					ob_clean();

			        header("Content-Type:	text/css;charset=UTF-8 \r\n");
				// Tell the user agent to cache this stylesheet for an hour
					$age = 3600;
					header( 'Expires: '.gmdate( 'D, d M Y H:i:s', time()+ $age ) . ' GMT' );
					header( 'Last-Modified: ' . gmdate( 'D, d M Y H:i:s', @filemtime( $strFileName ) ) . ' GMT' );
					header( 'Cache-Control: public, max-age='.$age.', must-revalidate, post-check=0, pre-check=0' );
					header( 'Pragma: public' );
			        exit($strFileContent); //we done!
				}
				else
				{
				    echo "The file $filename does not exist";
				}

			}

		//WORDPRESS SPECIFIC: we have to add '/' to file names, that's how SEO-friendly URLs are created in WordPress

		//Tag must look like <link  rel="stylesheet" href="http://SomeServer.com/wordpress/gra4/css/custom.css/" type="text/css" />

		//If we have '...custom.css', not '...custom.css/', it will cause redirect, and stylesheet file will never get cached.

			$aCssNames[$i] = $aCssNames[$i] . '/'; //so we fix it in array

		}

		$aGRA4GlobalConfig['include_css'] = implode(',',$aCssNames); //and put it back, already with '/'

		//ok, if we here - we've got real content

		$bFrameNeeded = true;

    	$content = GRA4FetchRemoteContent($bFrameNeeded);

		if($bFrameNeeded === false)
		{
			ob_clean();
			exit($content);
		}

//We do it to use default template, otherwise everything will be shifter right, and blink.
// so we display it hidden, and show only when custom.css is loaded.
//REDO! when we switch to custom template.
//Note: '.entry-header,.entry-title' here is butt-ugly, 
//  but otherwise it will blick "GRA4" into user eyes... looks like 24th frame =)
//	<div style="display:block; overflow:auto;">

		$start = '
	<style type="text/css">#gra4_wordpress, .entry-header, .entry-title {display:none;}</style>
		<div id="gra4_wordpress"  >';

		$end = '</div>';

		$content = $start.$content.$end;
   		return $content;
	}//END content_func
	

	function set_seo_friendly_rules($args)
	{

		$new = array();

		$permalink = get_permalink( $this->get_pageid()); //like 'http://server.com/wordpress/gra4/'

		$link = trim(str_replace(array(site_url(), 'index.php/'), '', $permalink), '/'); //like 'gra4'. 

		if($link !== '1gra4')
		{

//TODO - add error message ?

		}

		$new['(gra4)(/[-/0-9a-zA-Z]+)?/(.*)$'] = 'index.php?pagename=$matches[1]&page=$matches[2]'; //using constant

		return $new + $args;
	}


	function filter($content = '') {
		remove_all_filters('the_content');
		add_filter('the_content', array (&$this, 'filter'));
		
		if ( '' == $content || !strstr($content, '[GRA4_CONTENT]') ) { ob_flush();return $content; }
		return do_shortcode( '[GRA4_CONTENT]' );
	}


	function register_scripts() {
		wp_register_script(
		    'gra4_functions', //идентификатор
			plugin_dir_url(__FILE__).'js/functions.js',
		    array('jquery'), //зависимости
		    null, //версия
		    false //выполняем в header
//		    true //выполняем в body
		);	 
		wp_register_script(
		    'gra4_script', //идентификатор
			plugin_dir_url(__FILE__).'js/header.js',
		    array('jquery'), //зависимости
		    null, //версия
		    false //выполняем в header
//		    true //выполняем в body
		);	 
	}

	function enqueue_scripts(){
	  if (!is_admin()):
	    wp_enqueue_script('gra4_functions');
	    wp_enqueue_script('gra4_script');
	  endif; //!is_admin
	}


	function init_func($atts) 
	{
	// flush_rules() if our rules are not yet included
		$this->register_scripts();

		$rules = get_option( 'rewrite_rules' );

	//comment line bellow if you want to force flush

		if ( ! isset( $rules['(gra4)(/[-/0-9a-zA-Z]+)?/(.*)$'] ) ) //don't have to do it every time
		{
			global $wp_rewrite;
		   	$wp_rewrite->flush_rules();
		}
	}

	// copy file pre/post update plugin
	function gra4_copy($file, $source, $dest)
	{
	    // Make destination directory
	    if (!is_dir($dest)) {
	        mkdir($dest);
	    }		
	    // Simple copy for a file
	    if (is_file($source.$file)) {
	        return copy($source.$file, $dest.$file);
	    }	 
	    return true;
	}
	
	function gra4_backup($atts)
	{
		$upload_dir = wp_upload_dir(); 
		$file = 'custom.css';
        $from = dirname(__FILE__).'/css/';
       	$to = $upload_dir['path'].'/gra4_backup/';
	  	if( file_exists($from.$file)){
		    $this->gra4_copy($file, $from, $to);
		}
				
	    $from = dirname(__FILE__)."/";
		$file = 'gra4.cfg';
	    $this->gra4_copy($file, $from, $to);
	}
	
	function gra4_recover($atts)
	{
		$upload_dir = wp_upload_dir(); 
        $from = $upload_dir['path']."/gra4_backup/";
        $to = dirname(__FILE__)."/css/";
		$file = 'custom.css';
	  	if( file_exists($from.$file)){
        	$this->gra4_copy($file, $from, $to);
			unlink($from.$file);
	  	}
			
        $to = dirname(__FILE__)."/";
		$file = 'gra4.cfg';
        $this->gra4_copy($file, $from, $to);
		unlink($from.$file);
			
        $from = $upload_dir['path']."/gra4_backup/";
        if (is_dir($from)) {
        	rmdir($from);
		}
		
		add_option( 'gra4_dom_tree', 'none');
		add_option( 'gra4_dom_node_id', '');			
		add_option( 'gra4_margin_none', '1');			
		add_option( 'gra4_set_width', 'none');
		add_option( 'gra4_delta_width', '0');
		
		$dom_options = get_option( 'gra4_dom_tree');
		$dom_node_id = get_option( 'gra4_dom_node_id');
		$margin_option = get_option( 'gra4_margin_none');
		$set_width = get_option( 'gra4_set_width');
		$delta_width = get_option( 'gra4_delta_width');
		
		$this->set_place( $dom_node_id, $margin_option, $delta_width);
		
	}
	
}// END class Gra4

$gra4 = new Gra4();

?>
